moSetGetFields = {};

function moSetGetFields:setFieldsPriceUpdate(self, update, first)
	moFields = {};	
	moFields.length = 0;
	moFields.userId = 0;
	moFields.line = 20;
	moFields.table = 1;
	moFields.fieldsMax = table.getn(g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber);
	if moFields.fieldsMax > 0 then		
		local userId = g_currentMission:getServerUserId();          
		if userId ~= nil then
			moFields.userId = userId;
		end;
		moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "fields ", "");
		for a=1, moFields.fieldsMax do
			moFields[a] = {};
			moFields[a].fieldNumber = a;
			moFields[a].price = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldPrice;
			moFields[a].isBuy = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].ownedByPlayer;
			moFields[a].hectar = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldArea;			
		end;
		moFields.length = getFieldLength();		
	else
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "fieldsPrice ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .. "fieldsPrice ";end;
	end;
end;

function getFieldLength()
	local length = 50;
	local formel = moSetGetGui.pdaMenueSizeDefault*1000/5
	local posXfix = moSetGetGui.fontSizeX*moGuiMiniPDAsetGet.zoomOutInTemp+(moSetGetGui.fontSizeX*formel);	
	if moFields.fieldsMax <= 20 then length = posXfix*20;end;
	if moFields.fieldsMax > 20 and moFields.fieldsMax <= 40 then length = posXfix*40;moFields.table = 2;end;
	if moFields.fieldsMax > 40 and moFields.fieldsMax <= 60 then length = posXfix*60;moFields.table = 3;end;
	if moFields.fieldsMax > 60 and moFields.fieldsMax <= 80 then length = posXfix*85;moFields.table = 4;end;
	if moFields.fieldsMax > 80 and moFields.fieldsMax <= 100 then length = posXfix*110;moFields.table = 5;end;
	if moFields.fieldsMax > 100 and moFields.fieldsMax <= 120 then length = posXfix*135;moFields.table = 6;end;
	if moFields.fieldsMax > 120 and moFields.fieldsMax <= 140 then length = posXfix*160;moFields.table = 7;end;
	if moFields.fieldsMax > 140 and moFields.fieldsMax <= 160 then length = posXfix*190;moFields.table = 8;end;
	return length;
end;

function moSetGetFields:setFieldsDefination(self)
	moFieldDef = {};
	function getFieldValues(fieldDef)
		local fieldValues = {}
		if fieldDef ~= nil and fieldDef.fieldDimensions ~= nil then
			for a=0, getNumOfChildren(fieldDef.fieldDimensions) - 1 do
				local b1 = getChildAt(fieldDef.fieldDimensions, a);
				local b2 = getChildAt(b1, 0);
				local b3 = getChildAt(b1, 1);
				local c1 = { getWorldTranslation(b1) };
				local c2 = { getWorldTranslation(b2) };
				local c3 = { getWorldTranslation(b3) };
				local overlap = 10;
				local x1 = math.min(c1[1],c2[1],c3[1]) - overlap;
				local z1 = math.min(c1[3],c2[3],c3[3]) - overlap;
				local x2 = math.max(c1[1],c2[1],c3[1]) + overlap;
				local z2 = math.max(c1[3],c2[3],c3[3]) + overlap;
				table.insert(fieldValues, {x1=x1,z1=z1,x2=x2,z2=z2});
			end;
		end;
		return fieldValues;
    end
	if g_currentMission.fieldDefinitionBase ~= nil and g_currentMission.fieldDefinitionBase.fieldDefs ~= nil then
		for fieldNumber,fieldDef in ipairs(g_currentMission.fieldDefinitionBase.fieldDefs) do
            moFieldDef[fieldNumber] = {};
			moFieldDef[fieldNumber] = getFieldValues(fieldDef)
        end
    end	
end;