moSetGetPlaceableUpk = {};

---upk mods---
function moSetGetPlaceableUpk:setPlaceableUpkUpdate(self)	
	if not moDefault.upkMod then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableUpk ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableUpk ";end;
		return;
	end;
	moDefaultUpkPlaceable.objects = "";
	moDefaultUpkPlaceable.lengthObjects = 0;
	moDefault.warningPlaceableUpkProductivity = 100;
	moPlaceableUpk = {};	
	function checkPlaceableUpk(xmlUpkModString, name)
		if xmlUpkModString ~= nil then		
			setUpkPlaceableUpk(self, xmlUpkModString, name)				
		end;
	end;
	for a=1, moDefaultUpkPlaceable.objectsSearch do
		local xmlUpkModString = string.lower(moDefault.gameDir.. moDefaultUpkPlaceable.objectsMod[a]);
		local objectName = moDefaultUpkPlaceable.objectsName[a];
		checkPlaceableUpk(g_currentMission.placeables[xmlUpkModString], objectName);
	end;	
	if moDefaultUpkPlaceable.lengthObjects == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableUpk ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableUpk ";end;	
	end;	
end;

function setUpkPlaceableUpk(self, xmlUpkModString, objectName)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableUpk ", "");	
	if moPlaceableUpk[objectName] == nil then
		moDefaultUpkPlaceable.lengthObjects = moDefaultUpkPlaceable.lengthObjects+1;
		moPlaceableUpk[objectName] = {};
		moPlaceableUpk[objectName].length = 0;
		moPlaceableUpk[objectName].upk = true;
		moPlaceableUpk[objectName].objectName = unpack(moLanguage.extern[objectName.. "Upk".. moDefault.language]);	
		moPlaceableUpk[objectName].modName = nil;
		moPlaceableUpk[objectName].capacity = {};		
		moPlaceableUpk[objectName].fillLevel = {};		
		moPlaceableUpk[objectName].fillType = {};		
		moPlaceableUpk[objectName].fillTypeName = {};
		moPlaceableUpk[objectName].bestPrice = {};
		moPlaceableUpk[objectName].productivity = 0;
		moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['redDisabled'];
	end;
	local setFirstModName = false;	
	for k, v in pairs(xmlUpkModString) do			
		moPlaceableUpk[objectName].length = moPlaceableUpk[objectName].length+1					
		if not setFirstModName then setFirstModName = true;moPlaceableUpk[objectName].modName = xmlUpkModString[k].base.name;end;
		local a = 1;			
		for k1, v1 in pairs(xmlUpkModString[k].base.p_flbs) do
			if moPlaceableUpk[objectName].capacity[a] == nil then
				moPlaceableUpk[objectName].capacity[a] = xmlUpkModString[k].base.capacities.p_capacities[k1];
				moPlaceableUpk[objectName].fillLevel[a] = xmlUpkModString[k].base.p_flbs[k1].p_fillLevel;					
				local desc = Fillable.fillTypeIndexToDesc[k1];
				if desc ~= nil then
					moPlaceableUpk[objectName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
					if desc.name ~= "water" and desc.name ~= "seeds" and desc.name ~= "seeds2" and desc.name ~= "quellwasser" and desc.name ~= "manure" and desc.name ~= "compost" and desc.name ~= "fertilizer" then
						moPlaceableUpk[objectName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
						moPlaceableUpk[objectName].fillType[a] = false;
					else
						moPlaceableUpk[objectName].bestPrice[a] = 0;
						moPlaceableUpk[objectName].fillType[a] = true;
					end;
				else
					moPlaceableUpk[objectName].fillTypeName[a] = "unknow";
					moPlaceableUpk[objectName].bestPrice[a] = 0;
					moPlaceableUpk[objectName].fillType[a] = false;
				end;
			else
				moPlaceableUpk[objectName].capacity[a] = moPlaceableUpk[objectName].capacity[a]+xmlUpkModString[k].base.capacities.p_capacities[k1];				
				moPlaceableUpk[objectName].fillLevel[a] = moPlaceableUpk[objectName].fillLevel[a]+xmlUpkModString[k].base.p_flbs[k1].p_fillLevel;				
			end;								
			a = a+1;
		end;				
	end;
	if moPlaceableUpk[objectName].modName == nil then table.remove(moPlaceableUpk[objectName]);return;end;
	moDefaultUpkPlaceable.objects = moDefaultUpkPlaceable.objects.. objectName.. " ";
	if moPlaceableUpk[objectName].length > 0 then
		setPlaceableUpkProductivityColor(self, objectName);
	end;
end;

function setPlaceableUpkProductivityColor(self, objectName)
	local capacity = 0;
	local fillLevel = 0;	
	for a=1, table.getn(moPlaceableUpk[objectName].capacity) do
		if moPlaceableUpk[objectName].fillType[a] then
			capacity = capacity+moPlaceableUpk[objectName].capacity[a];
			fillLevel = fillLevel+moPlaceableUpk[objectName].fillLevel[a];
		end;
	end;		
	local ratio = string.format("%0.0f", Utils.getNoNil((fillLevel/capacity)*100, 0));
	moPlaceableUpk[objectName].productivity = ratio;	
	moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['green'];
	if tonumber(ratio) <= 95 and tonumber(ratio) >= 80 then
		moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) <= 80 and tonumber(ratio) >= 50 then
		moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) <= 50 and tonumber(ratio) >= 25 then
		moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['red'];
	elseif tonumber(ratio) <= 25 then
		moPlaceableUpk[objectName].productivityColor = moGuiExtras.colors['redDisabled'];
	end;
	if tonumber(moDefault.warningPlaceableUpkProductivity) >= tonumber(ratio) then 
		moDefault.warningPlaceableUpkProductivity = tonumber(ratio);	
	end;
end;